Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/ISOMIP/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/ISOMIP/MY_SRC/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/ISOMIP/MY_SRC/usrdef_zgr.F90	(revision 9125)
@@ -24,5 +24,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/LOCK_EXCHANGE/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/LOCK_EXCHANGE/MY_SRC/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/LOCK_EXCHANGE/MY_SRC/usrdef_zgr.F90	(revision 9125)
@@ -21,5 +21,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/OVERFLOW/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 9125)
@@ -23,5 +23,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/VORTEX/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/VORTEX/MY_SRC/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/VORTEX/MY_SRC/usrdef_zgr.F90	(revision 9125)
@@ -23,5 +23,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/bdyini.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/bdyini.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/bdyini.F90	(revision 9125)
@@ -29,5 +29,4 @@
    USE lib_mpp        ! for mpp_sum  
    USE iom            ! I/O
-   USE wrk_nemo       ! Memory Allocation
 
    IMPLICIT NONE
@@ -148,5 +147,5 @@
       INTEGER :: com_east_b, com_west_b, com_south_b, com_north_b  ! Flags for boundaries receiving
       INTEGER :: iw_b(4), ie_b(4), is_b(4), in_b(4)                ! Arrays for neighbours coordinates
-      REAL(wp), POINTER, DIMENSION(:,:)       ::   zfmask  ! temporary fmask array excluding coastal boundary condition (shlat)
+      REAL(wp), DIMENSION(jpi,jpj)       ::   zfmask  ! temporary fmask array excluding coastal boundary condition (shlat)
       !!
       CHARACTER(LEN=1)                     ::   ctypebdy   !     -        - 
@@ -1189,5 +1188,4 @@
       ! For the flagu/flagv calculation below we require a version of fmask without
       ! the land boundary condition (shlat) included:
-      CALL wrk_alloc(jpi,jpj,  zfmask ) 
       DO ij = 2, jpjm1
          DO ii = 2, jpim1
@@ -1318,5 +1316,4 @@
       IF( nb_bdy>0 )   DEALLOCATE( nbidta, nbjdta, nbrdta )
       !
-      CALL wrk_dealloc(jpi,jpj,   zfmask ) 
       !
    END SUBROUTINE bdy_segs
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/domain.F90	(revision 9125)
@@ -45,5 +45,4 @@
    USE lbclnk         ! ocean lateral boundary condition (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory Allocation
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/CONFIG/TEST_CASES/WAD/MY_SRC/usrdef_zgr.F90	(revision 9125)
@@ -24,5 +24,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 9125)
@@ -40,5 +40,4 @@
    USE prtctl          ! print control
    USE fldread         ! read input fields 
-   USE wrk_nemo        ! Memory allocation 
    USE timing          ! Timing
    USE trc, ONLY : ln_rsttr, numrtr, numrtw, lrst_trc
@@ -108,5 +107,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       INTEGER             ::   ji, jj, jk
-      REAL(wp), POINTER, DIMENSION(:,:)   :: zemp
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   :: zemp
       !!----------------------------------------------------------------------
       !
@@ -139,10 +138,10 @@
       !
       IF( .NOT.ln_linssh ) THEN
-         CALL wrk_alloc(jpi, jpj, zemp )
+         ALLOCATE( zemp(jpi,jpj) )
          zhdivtr(:,:,:) = sf_dyn(jf_div)%fnow(:,:,:) * tmask(:,:,:)    ! effective u-transport
          emp_b (:,:)    = sf_dyn(jf_empb)%fnow(:,:,1) * tmask(:,:,1)    ! E-P
          zemp   (:,:)   = 0.5_wp * ( emp(:,:) + emp_b(:,:) ) + rnf(:,:) + fwbcorr * tmask(:,:,1)
          CALL dta_dyn_ssh( kt, zhdivtr, sshb, zemp, ssha, e3t_a(:,:,:) )  !=  ssh, vertical scale factor & vertical transport
-         CALL wrk_dealloc(jpi, jpj, zemp )
+         DEALLOCATE( zemp )
          !                                           Write in the tracer restart file
          !                                          *******************************
@@ -587,8 +586,6 @@
       REAL(wp) ::   ztintb     ! ratio applied to before records when doing time interpolation
       INTEGER  ::   iswap 
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zuslp, zvslp, zwslpi, zwslpj
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zuslp, zvslp, zwslpi, zwslpj
       !!---------------------------------------------------------------------
-      !
-      CALL wrk_alloc(jpi, jpj, jpk, zuslp, zvslp, zwslpi, zwslpj )
       !
       IF( sf_dyn(jf_tem)%ln_tint ) THEN    ! Computes slopes (here avt is used as workspace)                       
@@ -660,6 +657,4 @@
       ENDIF
       !
-      CALL wrk_dealloc(jpi, jpj, jpk, zuslp, zvslp, zwslpi, zwslpj )
-      !
    END SUBROUTINE dta_dyn_slp
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 9125)
@@ -16,5 +16,4 @@
    !!                    conditions
    !!----------------------------------------------------------------------
-   USE wrk_nemo        ! Memory Allocation
    USE oce             ! ocean dynamics and tracers 
    USE dom_oce         ! ocean space and time domain
@@ -50,5 +49,5 @@
       INTEGER ::   jk, ii, ij, ib_bdy, ib, igrd     ! Loop counter
       LOGICAL ::   ll_dyn2d, ll_dyn3d, ll_orlanski
-      REAL(wp), POINTER, DIMENSION(:,:) :: pua2d, pva2d     ! after barotropic velocities
+      REAL(wp), DIMENSION(jpi,jpj) :: pua2d, pva2d     ! after barotropic velocities
       !!----------------------------------------------------------------------
       !
@@ -65,10 +64,4 @@
      &   .OR. cn_dyn3d(ib_bdy) == 'orlanski' .OR. cn_dyn3d(ib_bdy) == 'orlanski_npo')   ll_orlanski = .true.
       END DO
-
-      !-------------------------------------------------------
-      ! Set pointers
-      !-------------------------------------------------------
-
-      CALL wrk_alloc( jpi,jpj,   pua2d, pva2d ) 
 
       !-------------------------------------------------------
@@ -124,6 +117,4 @@
       END IF
       !
-      CALL wrk_dealloc( jpi,jpj,  pua2d, pva2d ) 
-      !
    END SUBROUTINE bdy_dyn
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 9125)
@@ -25,5 +25,4 @@
    USE fldread        !
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
@@ -75,5 +74,5 @@
       CHARACTER(len=80)                         ::   clfile              !: full file name for tidal input file 
       REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)    ::   dta_read            !: work space to read in tidal harmonics data
-      REAL(wp), POINTER, DIMENSION(:,:)         ::   ztr, zti            !:  "     "    "   "   "   "        "      " 
+      REAL(wp),ALLOCATABLE, DIMENSION(:,:)      ::   ztr, zti            !:  "     "    "   "   "   "        "      " 
       !!
       TYPE(TIDES_DATA),  POINTER                ::   td                  !: local short cut   
@@ -150,5 +149,5 @@
                ! given on the global domain (ie global, jpiglo x jpjglo)
                !
-               CALL wrk_alloc( jpi,jpj,   zti, ztr )
+               ALLOCATE( zti(jpi,jpj), ztr(jpi,jpj) )
                !
                ! SSH fields
@@ -200,5 +199,5 @@
                CALL iom_close( inum )
                !
-               CALL wrk_dealloc( jpi,jpj,   ztr, zti ) 
+               DEALLOCATE( ztr, zti ) 
                !
             ELSE            
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 9125)
@@ -17,5 +17,4 @@
    USE iom            ! I/O library (iom_get)
    USE in_out_manager ! I/O manager (ctmp1)
-   USE wrk_nemo                      ! Memory allocation
 
    IMPLICIT NONE
@@ -58,5 +57,5 @@
       REAL(wp) ::  zlam1, zcos_alpha, ze1, ze1deg  ! Case 5 local scalars
       REAL(wp) ::  zphi1, zsin_alpha, zim05, zjm05 !          
-      REAL(wp) , POINTER, DIMENSION(:,:) ::  gphidta, glamdta, zdist ! Global lat/lon
+      REAL(wp) , DIMENSION(jpidta,jpjdta) ::  gphidta, glamdta, zdist ! Global lat/lon
       !!
       NAMELIST/namdom/ nn_bathy, rn_bathy , rn_e3zps_min, rn_e3zps_rat, nn_msh, rn_hmin,   &
@@ -75,5 +74,4 @@
 902   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namdom in configuration namelist', lwp )
 
-      CALL wrk_alloc( jpidta,jpjdta,   gphidta, glamdta, zdist )
 
       ! ============================= !
@@ -183,6 +181,4 @@
       jpizoom = iloc(1) + nimpp - 2  ! Minloc index - 1; want the bottom-left
       jpjzoom = iloc(2) + njmpp - 2  ! corner index of the zoom domain.
-
-      CALL wrk_dealloc( jpidta,jpjdta,   gphidta, glamdta, zdist )
 
       IF (lwp) THEN
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90	(revision 9125)
@@ -18,5 +18,4 @@
    USE fldread        ! read input fields
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
 
@@ -139,5 +138,5 @@
       INTEGER ::   ik, il0, il1, ii0, ii1, ij0, ij1  ! local integers
       REAL(wp)::   zl, zi                            ! local floats
-      REAL(wp), POINTER, DIMENSION(:) ::  zup, zvp   ! 1D workspace
+      REAL(wp), ALLOCATABLE, DIMENSION(:) ::  zup, zvp   ! 1D workspace
       !!----------------------------------------------------------------------
       !
@@ -151,5 +150,5 @@
       IF( ln_sco ) THEN                   !==   s- or mixed s-zps-coordinate   ==!
          !
-         CALL wrk_alloc( jpk,   zup, zvp )
+         ALLOCATE( zup(jpk), zvp(jpk) )
          !
          IF( kt == nit000 .AND. lwp )THEN
@@ -187,5 +186,5 @@
          END DO
          ! 
-         CALL wrk_dealloc( jpk,   zup, zvp )
+         DEALLOCATE( zup, zvp )
          ! 
       ELSE                                !==   z- or zps- coordinate   ==!
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dyndmp.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dyndmp.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/C1D/dyndmp.F90	(revision 9125)
@@ -27,5 +27,4 @@
    USE lib_mpp        ! MPP library
    USE prtctl         ! Print control
-   USE wrk_nemo       ! Memory allocation
    USE timing         ! Timing
    USE iom            ! I/O manager
@@ -154,10 +153,9 @@
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::   zua, zva     ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zuv_dta   ! Read in data 
+      REAL(wp), DIMENSION(jpi,jpj,jpk,2) ::   zuv_dta   ! Read in data 
       !!----------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start( 'dyn_dmp' )
       !
-      CALL wrk_alloc( jpi,jpj,jpk,2,   zuv_dta )
       !
       !                           !==   read and interpolate U & V current data at kt   ==!
@@ -225,5 +223,4 @@
          &                           tab3d_2=va(:,:,:), clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      CALL wrk_dealloc( jpi,jpj,jpk,2,   zuv_dta )
       !
       IF( ln_timing )   CALL timing_stop( 'dyn_dmp')
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 9125)
@@ -36,5 +36,4 @@
    USE par_kind
    USE crslbclnk
-   USE wrk_nemo       ! work arrays
    USE lib_mpp
 
@@ -352,8 +351,7 @@
       INTEGER  ::   ji, jj, jk , ii, ij, je_2
       REAL(wp) ::   zdAm
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zvol, zmask      
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zvol, zmask      
       !!----------------------------------------------------------------  
       !
-      CALL wrk_alloc( jpi,jpj,jpk,   zvol, zmask )
       !
       p_fld1_crs(:,:,:) = 0._wp
@@ -445,5 +443,4 @@
       CALL crs_lbc_lnk( p_fld2_crs, cd_type, 1.0 ) 
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zvol, zmask )
       !
    END SUBROUTINE crs_dom_facvol
@@ -487,5 +484,5 @@
       INTEGER  ::   ii, ij, ijie, ijje, je_2
       REAL(wp) ::   zflcrs, zsfcrs   
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zsurf, zsurfmsk, zmask  
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   zsurf, zsurfmsk, zmask  
       !!----------------------------------------------------------------  
       !
@@ -496,5 +493,5 @@
       CASE ( 'VOL' )
          !
-         CALL wrk_alloc( jpi,jpj,jpk,   zsurf, zsurfmsk )
+         ALLOCATE( zsurf(jpi,jpj,jpk), zsurfmsk(jpi,jpj,jpk) )
          !   
          SELECT CASE ( cd_type )
@@ -585,9 +582,9 @@
                END SELECT
 
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
+              DEALLOCATE( zsurf, zsurfmsk )
 
          CASE ( 'SUM' )
          
-            CALL wrk_alloc( jpi, jpj, jpk, zsurfmsk )
+            ALLOCATE( zsurfmsk(jpi,jpj,jpk) )
 
             SELECT CASE ( cd_type )
@@ -763,9 +760,9 @@
               ENDIF
 
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurfmsk )
+              DEALLOCATE( zsurfmsk )
 
          CASE ( 'MAX' )    !  search the max of unmasked grid cells
 
-            CALL wrk_alloc( jpi, jpj, jpk, zmask )
+            ALLOCATE( zmask(jpi,jpj,jpk) )
 
             SELECT CASE ( cd_type )
@@ -934,9 +931,9 @@
               END SELECT
 
-              CALL wrk_dealloc( jpi, jpj, jpk, zmask )
+              DEALLOCATE( zmask )
 
          CASE ( 'MIN' )      !   Search the min of unmasked grid cells
 
-            CALL wrk_alloc( jpi, jpj, jpk, zmask )
+            ALLOCATE( zmask(jpi,jpj,jpk) )
 
             SELECT CASE ( cd_type )
@@ -1104,5 +1101,5 @@
             END SELECT
             !
-            CALL wrk_dealloc( jpi, jpj, jpk, zmask )
+            DEALLOCATE( zmask )
             !
          END SELECT
@@ -1149,5 +1146,5 @@
       INTEGER  :: ijie, ijje, ii, ij, je_2
       REAL(wp) :: zflcrs, zsfcrs   
-      REAL(wp), DIMENSION(:,:), POINTER :: zsurfmsk   
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: zsurfmsk   
       !!----------------------------------------------------------------  
       !
@@ -1158,5 +1155,5 @@
         CASE ( 'VOL' )
       
-            CALL wrk_alloc( jpi, jpj, zsurfmsk )
+            ALLOCATE( zsurfmsk(jpi,jpj) )
             zsurfmsk(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
 
@@ -1222,9 +1219,9 @@
             ENDDO
 
-            CALL wrk_dealloc( jpi, jpj, zsurfmsk )
+            DEALLOCATE( zsurfmsk )
 
          CASE ( 'SUM' )
          
-            CALL wrk_alloc( jpi, jpj, zsurfmsk )
+            ALLOCATE( zsurfmsk(jpi,jpj) )
             IF( PRESENT( p_e3 ) ) THEN
                zsurfmsk(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
@@ -1364,5 +1361,5 @@
               ENDIF
 
-              CALL wrk_dealloc( jpi, jpj, zsurfmsk )
+              DEALLOCATE( zsurfmsk )
 
          CASE ( 'MAX' )
@@ -1644,5 +1641,5 @@
       INTEGER ::  ijie, ijje, ii, ij, je_2
       REAL(wp) :: ze3crs  
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zmask, zsurf   
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zmask, zsurf   
 
       !!----------------------------------------------------------------  
@@ -1651,6 +1648,4 @@
        p_e3_max_crs(:,:,:) = 1.
    
-
-       CALL wrk_alloc( jpi, jpj, jpk, zmask, zsurf )
 
        SELECT CASE ( cd_type )
@@ -1756,5 +1751,4 @@
        CALL crs_lbc_lnk( p_e3_max_crs, cd_type, 1.0, pval=1.0 )  
        !              
-       CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zmask )
        !
    END SUBROUTINE crs_dom_e3
@@ -1773,10 +1767,8 @@
       INTEGER  :: ji, jj, jk                   ! dummy loop indices
       INTEGER  :: ii, ij, je_2
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk   
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zsurf, zsurfmsk   
       !!----------------------------------------------------------------  
       ! Initialize
 
-
-      CALL wrk_alloc( jpi, jpj, jpk, zsurf, zsurfmsk )
       !
       SELECT CASE ( cd_type )
@@ -1867,6 +1859,4 @@
       CALL crs_lbc_lnk( p_surf_crs    , cd_type, 1.0, pval=1.0 )
       CALL crs_lbc_lnk( p_surf_crs_msk, cd_type, 1.0, pval=1.0 )
-
-      CALL wrk_dealloc( jpi, jpj, jpk, zsurfmsk, zsurf )
 
    END SUBROUTINE crs_dom_sfc
@@ -2236,8 +2226,6 @@
       !!  local variables
       INTEGER  :: ji,jj,jk      ! dummy indices
-      REAL(wp), DIMENSION(:,:)  , POINTER :: zmbk
+      REAL(wp), DIMENSION(jpi_crs, jpj_crs) :: zmbk
       !!----------------------------------------------------------------
-   
-      CALL wrk_alloc( jpi_crs, jpj_crs, zmbk )
    
       mbathy_crs(:,:) = jpkm1
@@ -2281,6 +2269,4 @@
       zmbk(:,:) = REAL( mbkv_crs(:,:), wp )   ;   CALL crs_lbc_lnk(zmbk,'V',1.0) ; mbkv_crs  (:,:) = MAX( INT( zmbk(:,:) ), 1 ) 
       !
-      CALL wrk_dealloc( jpi_crs, jpj_crs, zmbk )
-      !
    END SUBROUTINE crs_dom_bat
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 9125)
@@ -19,5 +19,4 @@
    USE crsdom         ! coarse grid domain
    USE crslbclnk       ! crs mediator to lbclnk
-   USE wrk_nemo        ! Working array
 
    IMPLICIT NONE
@@ -63,13 +62,9 @@
       INTEGER           ::   ji, jj, jk   ! dummy loop indices
       !                                   !  workspaces
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zprt, zprw 
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zdepu, zdepv
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: ze3tp, ze3wp
-      !!----------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi_crs, jpj_crs,      zprt , zprw  )
-      CALL wrk_alloc( jpi_crs, jpj_crs,      ze3tp, ze3wp )
-      CALL wrk_alloc( jpi_crs, jpj_crs, jpk, zdepu, zdepv )
-
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs    ) :: zprt, zprw 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk) :: zdepu, zdepv
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs    ) :: ze3tp, ze3wp
+      !!----------------------------------------------------------------------
+      !
       ze3tp(:,:) = 0.0
       ze3wp(:,:) = 0.0
@@ -289,8 +284,4 @@
       END SELECT
       !
-      CALL wrk_dealloc( jpi_crs, jpj_crs,      zprt , zprw  )
-      CALL wrk_dealloc( jpi_crs, jpj_crs,      ze3tp, ze3wp )
-      CALL wrk_dealloc( jpi_crs, jpj_crs, jpk, zdepu, zdepv )
-      !
    END SUBROUTINE crs_dom_wri
 
@@ -312,8 +303,6 @@
       INTEGER  ::  ji       ! dummy loop indices
       LOGICAL, DIMENSION(SIZE(puniq,1),SIZE(puniq,2),1) ::  lldbl  ! store whether each point is unique or not
-      REAL(wp), POINTER, DIMENSION(:,:) :: ztstref
-      !!----------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi_crs, jpj_crs, ztstref )
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs) :: ztstref
+      !!----------------------------------------------------------------------
       !
       ! build an array with different values for each element 
@@ -331,6 +320,4 @@
       puniq(nldi_crs:nlei_crs,nldj_crs:nlej_crs) = REAL( COUNT( lldbl(nldi_crs:nlei_crs,nldj_crs:nlej_crs,:), dim = 3 ) , wp )
       !
-      CALL wrk_dealloc( jpi_crs, jpj_crs, ztstref )
-      !
    END SUBROUTINE dom_uniq_crs
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 9125)
@@ -22,5 +22,4 @@
    USE in_out_manager
    USE lib_mpp
-   USE wrk_nemo 
 
    IMPLICIT NONE
@@ -72,5 +71,5 @@
       INTEGER  :: ierr                                ! allocation error status
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      REAL(wp), DIMENSION(:,:,:), POINTER :: ze3t, ze3u, ze3v, ze3w
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t, ze3u, ze3v, ze3w
 
       NAMELIST/namcrs/ nn_factx, nn_facty, nn_binref, nn_msh_crs, nn_crs_kz, ln_crs_wn
@@ -180,6 +179,4 @@
      
      !
-     CALL wrk_alloc( jpi,jpj,jpk,   ze3t, ze3u, ze3v, ze3w )
-     !
      ze3t(:,:,:) = e3t_n(:,:,:)
      ze3u(:,:,:) = e3u_n(:,:,:)
@@ -245,5 +242,4 @@
       ! 7. Finish and clean-up
       !---------------------------------------------------------
-      CALL wrk_dealloc( jpi,jpj,jpk,   ze3t, ze3u, ze3v, ze3w )
       !
    END SUBROUTINE crs_init
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 9125)
@@ -22,5 +22,4 @@
    USE fldread        ! type FLD_N
    USE timing         ! preformance summary
-   USE wrk_nemo       ! working arrays
 
    IMPLICIT NONE
@@ -76,8 +75,9 @@
       REAL(wp) ::   zaw, zbw, zrw
       !
-      REAL(wp), POINTER, DIMENSION(:,:)     :: zarea_ssh , zbotpres       ! 2D workspace 
-      REAL(wp), POINTER, DIMENSION(:,:)     :: zpe                         ! 2D workspace 
-      REAL(wp), POINTER, DIMENSION(:,:,:)   :: zrhd , zrhop               ! 3D workspace
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztsn                       ! 4D workspace
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)     :: zarea_ssh , zbotpres       ! 2D workspace 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)     :: zpe                         ! 2D workspace 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   :: zrhd , zrhop               ! 3D workspace
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) :: ztsn                       ! 4D workspace
+
       !!--------------------------------------------------------------------
       IF( ln_timing )   CALL timing_start('dia_ar5')
@@ -85,8 +85,8 @@
       IF( kt == nit000 )     CALL dia_ar5_init
 
-      IF( l_ar5 ) THEN
-         CALL wrk_alloc( jpi , jpj              , zarea_ssh , zbotpres )
-         CALL wrk_alloc( jpi , jpj , jpk        , zrhd      , zrhop    )
-         CALL wrk_alloc( jpi , jpj , jpk , jpts , ztsn                 )
+      IF( l_ar5 ) THEN 
+         ALLOCATE( zarea_ssh(jpi,jpj) , zbotpres(jpi,jpj) )
+         ALLOCATE( zrhd(jpi,jpj,jpk) , zrhop(jpi,jpj,jpk) )
+         ALLOCATE( ztsn(jpi,jpj,jpk,jpts) )
          zarea_ssh(:,:) = area(:,:) * sshn(:,:)
       ENDIF
@@ -212,5 +212,5 @@
       ! Exclude points where rn2 is negative as convection kicks in here and
       ! work is not being done against stratification
-         CALL wrk_alloc( jpi, jpj, zpe )
+         ALLOCATE( zpe(jpi,jpj) )
          zpe(:,:) = 0._wp
          IF( ln_zdfddm ) THEN
@@ -247,11 +247,11 @@
 !!gm           CALL lbc_lnk( zpe, 'T', 1._wp)         
           CALL iom_put( 'tnpeo', zpe )
-          CALL wrk_dealloc( jpi, jpj, zpe )
-      ENDIF
-      !
+          DEALLOCATE( zpe )
+      ENDIF
+
       IF( l_ar5 ) THEN
-        CALL wrk_dealloc( jpi , jpj              , zarea_ssh , zbotpres )
-        CALL wrk_dealloc( jpi , jpj , jpk        , zrhd      , zrhop    )
-        CALL wrk_dealloc( jpi , jpj , jpk , jpts , ztsn                 )
+        DEALLOCATE( zarea_ssh , zbotpres )
+        DEALLOCATE( zrhd      , zrhop    )
+        DEALLOCATE( ztsn                 )
       ENDIF
       !
@@ -274,9 +274,7 @@
       !
       INTEGER    ::  ji, jj, jk
-      REAL(wp), POINTER, DIMENSION(:,:)  :: z2d
+      REAL(wp), DIMENSION(jpi,jpj)  :: z2d
 
     
-
-      CALL wrk_alloc( jpi, jpj, z2d )
       z2d(:,:) = pua(:,:,1) 
       DO jk = 1, jpkm1
@@ -315,6 +313,4 @@
        ENDIF
           
-       CALL wrk_dealloc( jpi, jpj, z2d )
-
    END SUBROUTINE dia_ar5_hst
 
@@ -330,5 +326,5 @@
       INTEGER  ::   ji, jj, jk  ! dummy loop indices
       REAL(wp) ::   zztmp  
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zsaldta   ! Jan/Dec levitus salinity
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   zsaldta   ! Jan/Dec levitus salinity
       !
       !!----------------------------------------------------------------------
@@ -341,5 +337,4 @@
       IF( l_ar5 ) THEN
          !
-         CALL wrk_alloc( jpi , jpj , jpk, jpts, zsaldta )
          !                                      ! allocate dia_ar5 arrays
          IF( dia_ar5_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'dia_ar5_init : unable to allocate arrays' )
@@ -357,24 +352,27 @@
          IF( lk_mpp )   CALL mpp_sum( vol0 )
 
-         CALL iom_open ( 'sali_ref_clim_monthly', inum )
-         CALL iom_get  ( inum, jpdom_data, 'vosaline' , zsaldta(:,:,:,1), 1  )
-         CALL iom_get  ( inum, jpdom_data, 'vosaline' , zsaldta(:,:,:,2), 12 )
-         CALL iom_close( inum )
-
-         sn0(:,:,:) = 0.5_wp * ( zsaldta(:,:,:,1) + zsaldta(:,:,:,2) )        
-         sn0(:,:,:) = sn0(:,:,:) * tmask(:,:,:)
-         IF( ln_zps ) THEN               ! z-coord. partial steps
-            DO jj = 1, jpj               ! interpolation of salinity at the last ocean level (i.e. the partial step)
-               DO ji = 1, jpi
-                  ik = mbkt(ji,jj)
-                  IF( ik > 1 ) THEN
-                     zztmp = ( gdept_1d(ik) - gdept_0(ji,jj,ik) ) / ( gdept_1d(ik) - gdept_1d(ik-1) )
-                     sn0(ji,jj,ik) = ( 1._wp - zztmp ) * sn0(ji,jj,ik) + zztmp * sn0(ji,jj,ik-1)
-                  ENDIF
-               END DO
-            END DO
+         IF( iom_use( 'sshthster' ) ) THEN
+            ALLOCATE( zsaldta(jpi,jpj,jpj,jpts) )
+            CALL iom_open ( 'sali_ref_clim_monthly', inum )
+            CALL iom_get  ( inum, jpdom_data, 'vosaline' , zsaldta(:,:,:,1), 1  )
+            CALL iom_get  ( inum, jpdom_data, 'vosaline' , zsaldta(:,:,:,2), 12 )
+            CALL iom_close( inum )
+
+            sn0(:,:,:) = 0.5_wp * ( zsaldta(:,:,:,1) + zsaldta(:,:,:,2) )        
+            sn0(:,:,:) = sn0(:,:,:) * tmask(:,:,:)
+            IF( ln_zps ) THEN               ! z-coord. partial steps
+               DO jj = 1, jpj               ! interpolation of salinity at the last ocean level (i.e. the partial step)
+                  DO ji = 1, jpi
+                     ik = mbkt(ji,jj)
+                     IF( ik > 1 ) THEN
+                        zztmp = ( gdept_1d(ik) - gdept_0(ji,jj,ik) ) / ( gdept_1d(ik) - gdept_1d(ik-1) )
+                        sn0(ji,jj,ik) = ( 1._wp - zztmp ) * sn0(ji,jj,ik) + zztmp * sn0(ji,jj,ik-1)
+                     ENDIF
+                  END DO
+               END DO
+            ENDIF
+            !
+            DEALLOCATE( zsaldta )
          ENDIF
-         !
-         CALL wrk_dealloc( jpi , jpj , jpk, jpts, zsaldta )
          !
       ENDIF
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 9125)
@@ -506,8 +506,8 @@
                 istart,iend      !first and last points selected in listpoint
      INTEGER :: jpoint           !loop on list points
-     INTEGER, POINTER, DIMENSION(nb_point_max)   :: idirec !contains temporary sec%direction
-     INTEGER, POINTER, DIMENSION(2,nb_point_max) :: icoord !contains temporary sec%listpoint
+     INTEGER, DIMENSION(nb_point_max)   :: idirec !contains temporary sec%direction
+     INTEGER, DIMENSION(2,nb_point_max) :: icoord !contains temporary sec%listpoint
      !----------------------------------------------------------------------------
-      !
+     !
      IF( ld_debug )WRITE(numout,*)'      -------------------------'
      IF( ld_debug )WRITE(numout,*)'      removepoints in listpoint'
@@ -559,4 +559,5 @@
       !
    END SUBROUTINE removepoints
+
 
    SUBROUTINE transport(sec,ld_debug,jsec)
